function getContent(mode) {
	var html = content.innerHTML;
	html = html.replace(/&nbsp;/g," ");
	mysword.getContent(html, mode);
}
function copy() {
	//document.execCommand('copy',true,null);
	var selection = window.getSelection();
	mysword.setContent(selection.toString());
	/*var range = selection.getRangeAt(0); 
	if (range) { 
		var div = document.createElement('div'); 
		div.appendChild(range.cloneContents()); 
		mysword.setContent(div.innerHTML);
	}*/
}
function paste() {
	document.execCommand('paste',true,null);
}
function execCommand(command,param) {
	document.execCommand(command,false,param);
	rememberPosition();
}
function applyFormat(css) {
	if (css.substring(0, 2) === "xh")
		css = css.substring(1);
	rememberPosition();
	if (!range) return;
	if (range.isCollapsed){
		return;
	}
	var el,pos,par;
	if (range.startOffset==0 && range.endOffset==range.endContainer.length){
		el=getCommonAncestor(range.startContainer,range.endContainer);
		if (el.firstChild==range.startContainer && el.lastChild==range.endContainer){
			if (el.nodeType==3) el=el.parentNode;
			//mysword.log(el.nodeType+'/'+el.nodeName+'/'+el.className);
			if (el.nodeType==1){
				if (el.nodeName=='SPAN' && el.className!=''){
					css = el.className+' '+css;
					par = el.parentNode;
					pos = Array.prototype.indexOf.call(par.childNodes, el);
				} else if (el.nodeName=='A'){
					selectNode(el);
					rememberPosition();
				}
			}
		}
	}
	var s = range.startContainer;
	var text = null;
	var p = null;
	if (range.startOffset==0 && s.nodeType==3 && s.parentNode.tagName=='P') {
		// fix for first word in p not styleable, worked only for first time
		p = s.parentNode;
		text = document.createTextNode('.&nbsp;');
		p.insertBefore(text, p.firstChild);
	}
    var div = document.createElement('div');
	div.appendChild(range.cloneContents());
	var html = div.innerHTML;
    html="<span class='"+css+"'>"+html+"</span>";
    document.execCommand('insertHTML',false,html);
	mysword.log(html);
	if (p != null)
		p.removeChild(text);
    // restore position is not perfect for first word only
	//mysword.log(s.nodeType+":"+s.textContent);
	if (s.nodeType==1) {
		// can't make this work yet
		/*var r = document.createRange();
		r.setStart(range.startOffset);
		r.setEnd(range.endOffset);
		range = r;
		var sel = window.getSelection();
	    sel.removeAllRanges();
	    sel.addRange(range);*/
		return;
	}
	if (par) {
		//mysword.log("pos "+par.childNodes[pos]);
		s = par.childNodes[pos];
	} else
		s = s.previousSibling;
	selectNode(s);
	rememberPosition();
    //restorePosition();
    //execCommand('insertHTML',html);
}
function removeFormat() {
	rememberPosition();
	if (!range) return;
	if (range.isCollapsed) return;
    var div = document.createElement('div');
	div.appendChild( range.cloneContents().cloneNode(true) );
	var html = div.innerHTML;
	html = html.replace(/<\/?span[^>]*>/g,"");
	//mysword.log(html);
    document.execCommand('insertHTML',false,html);
}
function deleteLine() {
	rememberPosition();
	if (!range) return;
	var el=range.startContainer;
	if (el.nodeType==3) el=el.parentNode;
	do {
		var n = el.tagName;
		if (n=='P' || n=='H1' || n=='H2' || n=='H3' || n=='H4' || n=='H5' || n=='H6' || n=='LI' || n=='TR' || n=='BLOCKQUOTE')
			break;
		el=el.parentNode;
	} while (el);
	if (el) {
		var r = document.createRange();
		r.selectNode(el);
		var sel = window.getSelection();
	    sel.removeAllRanges();
	    sel.addRange(r);
		execCommand('delete');
	}
}
function getCommonAncestor(node1, node2) {
    var method = "contains" in node1 ? "contains" : "compareDocumentPosition",
        test   = method === "contains" ? 1 : 0x10;
    while (node1 = node1.parentNode) {
        if ((node1[method](node2) & test) === test)
            return node1;
    }
    return null;
}
function setContent(text) {
	var r = document.createRange();
	r.selectNodeContents(content);
	var sel = window.getSelection();
    sel.removeAllRanges();
    sel.addRange(r);
    execCommand('delete');
    execCommand('formatBlock','p');
    execCommand('insertHTML',text);
}
function redo() {
	execCommand('redo');
}
function undo() {
	execCommand('undo');
}
function indent() {
	if (!range) return;
	// check if empty line to prevent crash
	var el=range.startContainer;
	//mysword.log("indent: "+el.nodeType+":"+el.parentElement.nodeValue+"/"+el.nodeName+"/"+el.nodeValue);
	if (el.nodeType==1 && el.nodeName=='P' && el.nodeValue==null) return;
	execCommand('indent');
}
function outdent() {
	execCommand('outdent');
}
function selectAll() {
	selectNode(content);
}
function copy() {
	rememberPosition();
	if (!range) return;
	if (range.isCollapsed) return;
    var div = document.createElement('div');
	div.appendChild( range.cloneContents().cloneNode(true) );
	var html = div.innerHTML;
	mysword.copy(html);
}
function cut() {
	rememberPosition();
	if (!range) return;
	if (range.isCollapsed) return;
    var div = document.createElement('div');
	div.appendChild( range.cloneContents().cloneNode(true) );
	var html = div.innerHTML;
    execCommand('delete');
	mysword.copy(html);
}
function pageUp() {
	range = document.createRange();
    range.selectNodeContents(content);
    range.collapse(true);
    var sel = window.getSelection();
    sel.removeAllRanges();
    sel.addRange(range);
}
function pageDown() {
	range = document.createRange();
    range.selectNodeContents(content);
    range.collapse(false);
    var sel = window.getSelection();
    sel.removeAllRanges();
    sel.addRange(range);
}
function getLink() {
	var el = getLinkOnCursor();
	if (el)
		mysword.getLink(el.href);
}
function editLink() {
	var el = getLinkOnCursor(false);
	if (el) {
		range = document.createRange();
	    range.selectNodeContents(el);
	    var sel = window.getSelection();
	    sel.removeAllRanges();
	    sel.addRange(range);
		mysword.editLink(el.href, el.innerHTML);
	} else
		mysword.editLink(null, null);
}
function getLinkOnCursor() {
    var sel = window.getSelection();
    if (sel.rangeCount)
        range = sel.getRangeAt(0).cloneRange();
	if (!range) return null;
	var el=range.startContainer;
	if (el.nodeType==3) el=el.parentNode;
	do {
		var n = el.tagName;
		if (n == 'A')
			break;
		el=el.parentNode;
	} while (el);
	if (!el) {
		el=range.startContainer;
    	//mysword.log(el+"/"+el.tagName)
		while (el && el.tagName != 'A') {
			if (el.parentNode && el.parentNode.tagName == 'SPAN' && !el.previousSibling)
				el = el.parentNode;
			else
        		el = el.previousSibling;
        	//mysword.log(""+el)
        	if (el && el.nodeType==1) {
        		var ls = el.getElementsByTagName('A');
        		if (ls.length > 0) {
        			el = ls[ls.length-1];
        			//mysword.log(el+"/"+el.href)
        			break;
        		}
        	}
    	}
	}
	return el;
}
function selectNode(node) {
	range = document.createRange();
	range.selectNode(node);
	var sel = window.getSelection();
	sel.removeAllRanges();
	sel.addRange(range);
}
function restorePosition() {
	if (range) {
		var sel = window.getSelection();
	    sel.removeAllRanges();
	    sel.addRange(range);
        //mysword.log("restore: "+range.startContainer+":"+range.startOffset+"/"+range.toString());
    }
}
function rememberPosition() {
    var sel = window.getSelection();
    if (sel.rangeCount) {
        range = sel.getRangeAt(0).cloneRange();
        //mysword.log("selection: "+range.startContainer+":"+range.startOffset+"/"+range.toString());
    } else
    	range=null;
}
var content, range, blurRange;
function onload() {
	content=document.getElementById('content');
	// This will make Jelly bean selection without handles
	//document.designMode='on';
	document.execCommand('defaultParagraphSeparator',false,'p');
	scroll();
	// onblur/onfocus is better but does not work here due to timing (it worked in TinyMCE)
	var change=function() {
		rememberPosition();
	};
	content.onkeyup=change;
	content.onmouseup=change;
    content.onclick = function(e) {
    	var el = e.target;
    	//mysword.log('click '+el);
        if (el.tagName == 'IMG') {
        	selectNode(el);
            mysword.editImage(el.src, el.getAttribute('style'));
        }
    };
    // onchange does not work; the work around will not work from list to paragraph
	content.onkeydown = function(e) {
		if (e.which != 13) return;
		rememberPosition();
		if (range) {
			var el=range.startContainer;
			if (el.nodeType==3) el=el.parentNode;
			if (el.nodeName == 'P') {
				mysword.newParagraph();
			}
		}
    };
    // Selection seems to be gone onblur but in TinyMCE it is not
	/*content.onblur = function(e) {
    	var sel = window.getSelection();
	    if (sel.rangeCount) {
    		mysword.log('blur');
	        blurRange = sel.getRangeAt(0).cloneRange();
	    }
    };
    content.onfocus = function(e) {
    	if (blurRange) {
    		mysword.log('focus');
			var sel = window.getSelection();
		    sel.removeAllRanges();
		    sel.addRange(blurRange);
	    }
    };*/
	mysword.log('onload');
}
function scroll(){
	var b=document.getElementById('backimg');
	var p=window.pageYOffset;var h=document.body.scrollHeight;
	if(p+b.offsetHeight>h)p=h-b.offsetHeight;
	b.style.top=p+'px';
}
